﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Fractal
{
    public partial class FractalDialog : Form
    {
        private int _recursionDepth;
        public int RecursionDepth
        {
            get
            {
                return _recursionDepth;
            }
            set
            {
                recursionUpDown.Value = value;
                _recursionDepth = value;
            }
        }

        private Color _colour;
        public Color Colour
        {
            get
            {
                return _colour;
            }
            set
            {
                colourButton.BackColor = value;
                _colour = value;
            }
        }

        public FractalDialog()
        {
            InitializeComponent();
        }

        private void colourButton_Click(object sender, EventArgs e)
        {
            ColorDialog diag = new ColorDialog();

            if (diag.ShowDialog() == DialogResult.OK)
            {
                colourButton.BackColor = diag.Color;
            }
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;

            Close();
        }

        private void confirmButton_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;

            RecursionDepth = (int)recursionUpDown.Value;
            Colour = colourButton.BackColor;

            Close();
        }
    }
}
