﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Fractal
{
    public partial class MainForm : Form
    {
        private int recursionDepth;
        private Pen pen;

        public MainForm()
        {
            InitializeComponent();

            Paint += DrawFractal;

            recursionDepth = 0;
            pen = Pens.Black;
        }

        private void DrawFractal(object sender, PaintEventArgs e)
        {
            if (recursionDepth == 0)
            {
                return;
            }

            DrawFractal(e.Graphics, 200, 100, 400, 300, 1);
        }

        private void DrawFractal(Graphics g, int x, int y, int width, int height, int level)
        {
            g.DrawLine(pen, new Point(x, (y + height)), new Point((x + width), (y + height)));
            g.DrawLine(pen, new Point((x + (width / 2)), y), new Point(x, (y + height)));
            g.DrawLine(pen, new Point((x + (width / 2)), y), new Point((x + width), (y + height)));

            if (level < recursionDepth)
            {
                DrawFractal(g, x, (y + (height / 2)), (width / 2), (height / 2), (level + 1));
                DrawFractal(g, (x + (width / 2)), (y + (height / 2)), (width / 2), (height / 2), (level + 1));
                DrawFractal(g, (x + (width / 4)), y, (width / 2), (height / 2), (level + 1));
            }
        }

        private void drawButton_Click(object sender, EventArgs e)
        {
            FractalDialog diag = new FractalDialog();

            if (recursionDepth > 0)
            {
                diag.RecursionDepth = recursionDepth;
                diag.Colour = pen.Color;
            }

            if (diag.ShowDialog() == DialogResult.OK)
            {
                recursionDepth = diag.RecursionDepth;
                pen = new Pen(diag.Colour);
                Invalidate();
            }
        }
    }
}
